commit 4636d61e9ad2a57a9c072e60f9d30429e83c2f4e
Author: Kewen Lin <linkw@linux.ibm.com>
Date:   Tue Nov 30 04:22:32 2021

    rs6000: Remove builtin mask check from builtin_decl [PR102347]
    
    As the discussion in PR102347, currently builtin_decl is invoked so
    early, it's when making up the function_decl for builtin functions,
    at that time the rs6000_builtin_mask could be wrong for those
    builtins sitting in #pragma/attribute target functions, though it
    will be updated properly later when LTO processes all nodes.
    
    This patch is to align with the practice i386 port adopts, also
    align with r10-7462 by relaxing builtin mask checking in some places.
    
    gcc/ChangeLog:
    
            PR target/102347
            * config/rs6000/rs6000-call.c (rs6000_builtin_decl): Remove builtin mask
            check.
    
    gcc/testsuite/ChangeLog:
    
            PR target/102347
            * gcc.target/powerpc/pr102347.c: New test.
    
    (cherry picked from commit 6c7d489a1e6592bc73db03678c1231748fd7a126)

diff --git a/gcc/config/rs6000/rs6000-call.c b/gcc/config/rs6000/rs6000-call.c
index af385072151..84b591512c4 100644
--- a/gcc/config/rs6000/rs6000-call.c
+++ b/gcc/config/rs6000/rs6000-call.c
@@ -13655,23 +13655,17 @@ rs6000_init_builtins (void)
     }
 }
 
-/* Returns the rs6000 builtin decl for CODE.  */
+/* Returns the rs6000 builtin decl for CODE.  Note that we don't check
+   the builtin mask here since there could be some #pragma/attribute
+   target functions and the rs6000_builtin_mask could be wrong when
+   this checking happens, though it will be updated properly later.  */
 
 tree
 rs6000_builtin_decl (unsigned code, bool initialize_p ATTRIBUTE_UNUSED)
 {
-  HOST_WIDE_INT fnmask;
-
   if (code >= RS6000_BUILTIN_COUNT)
     return error_mark_node;
 
-  fnmask = rs6000_builtin_info[code].mask;
-  if ((fnmask & rs6000_builtin_mask) != fnmask)
-    {
-      rs6000_invalid_builtin ((enum rs6000_builtins)code);
-      return error_mark_node;
-    }
-
   return rs6000_builtin_decls[code];
 }
 
diff --git a/gcc/testsuite/gcc.target/powerpc/pr102347.c b/gcc/testsuite/gcc.target/powerpc/pr102347.c
new file mode 100644
index 00000000000..05c439a8dac
--- /dev/null
+++ b/gcc/testsuite/gcc.target/powerpc/pr102347.c
@@ -0,0 +1,15 @@
+/* { dg-do link } */
+/* { dg-require-effective-target power10_ok } */
+/* { dg-require-effective-target lto } */
+/* { dg-options "-flto -mdejagnu-cpu=power9" } */
+
+/* Verify there are no error messages in LTO mode.  */
+
+#pragma GCC target "cpu=power10"
+int main ()
+{
+  float *b;
+  __vector_quad c;
+  __builtin_mma_disassemble_acc (b, &c);
+  return 0;
+}

